---
- name: Converge
  hosts: all
  gather_facts: false
  pre_tasks:
    - set_fact:
        ansible_cust_password_file: "{{ molecule_ephemeral_directory }}/{{ inventory_hostname }}_updated_password.txt"
        ansible_cust_host_file: "{{ molecule_ephemeral_directory }}/{{ inventory_hostname }}_updated_host.txt"
        ansible_cust_user_file: "{{ molecule_ephemeral_directory }}/{{ inventory_hostname }}_updated_user.txt"
    - set_fact:
        ansible_password_tmp: "{{ lookup('file', ansible_cust_password_file, errors='ignore') }}"
        ansible_host_tmp: "{{ lookup('file', ansible_cust_host_file, errors='ignore') }}"
        ansible_user_tmp: "{{ lookup('file', ansible_cust_user_file, errors='ignore') }}"
    - set_fact:
        ansible_password: "{{ ansible_password_tmp }}"
      when: (ansible_password_tmp | length) > 0
    - set_fact:
        ansible_host: "{{ ansible_host_tmp }}"
      when: (ansible_host_tmp | length) > 0
    - set_fact:
        ansible_user: "{{ ansible_user_tmp }}"
      when: (ansible_user_tmp | length) > 0
    - debug:
        var: ansible_password
    - debug:
        var: ansible_host
    - debug:
        var: ansible_user
    - name: Gather facts
      setup:
    - set_fact:
        ipv4_addresses_tmp: "[{% for x in ansible_ip_addresses %}{{ x + ',' if (x | ansible.netcommon.ipv4) }}{% endfor %}]"
    - set_fact:
        ipv4_addresses: "{{ ipv4_addresses_tmp | from_yaml }}"
  roles:
    - role: "ansible_role_new_domain"
      new_domain_domainadmin_password: P@ssw0rd!
      new_domain_localadmin_password: P@ssw0rd!
      new_domain_domain_safe_mode_password: P@ssw0rd!
      new_domain_static_ips: "{{ ipv4_addresses }}"
      new_domain_gws: "{{ ansible_interfaces | selectattr('default_gateway', 'defined') | map(attribute='default_gateway') }}"
      new_domain_dns_ips:
        - ["8.8.8.8", "8.8.8.7"]
        - ["8.8.8.9", "8.8.8.8"]
      new_domain_newhostname: dc1
      new_domain_domain: test.net
      new_domain_netbios: TEST
  tasks:
    - name: Dump updated_password.txt
      copy:
        content: "{{ ansible_password }}"
        dest: "{{ ansible_cust_password_file }}"
      delegate_to: localhost

    - name: Dump updated_host.txt
      copy:
        content: "{{ ansible_host }}"
        dest: "{{ ansible_cust_host_file }}"
      delegate_to: localhost

    - name: Dump updated_user.txt
      copy:
        content: "{{ ansible_user }}"
        dest: "{{ ansible_cust_user_file }}"
      delegate_to: localhost
